#include<bits/stdc++.h>
#include <unistd.h>

#define REP(i, n) for(int i = 0; i < n; i++)

using namespace std;

typedef pair<int, int> ii;

int n = 100000;

int rnd(int a, int b){
	return a + (rand() % (b-a+1));
}



// http://www.concentric.net/~Ttwang/tech/inthash.htm
// Workaround kvuli seedu na srand - proces se spousti mnohokrat za sekundu
unsigned long mix(unsigned long a, unsigned long b, unsigned long c)
{
    a=a-b;  a=a-c;  a=a^(c >> 13);
    b=b-c;  b=b-a;  b=b^(a << 8);
    c=c-a;  c=c-b;  c=c^(b >> 13);
    a=a-b;  a=a-c;  a=a^(c >> 12);
    b=b-c;  b=b-a;  b=b^(a << 16);
    c=c-a;  c=c-b;  c=c^(b >> 5);
    a=a-b;  a=a-c;  a=a^(c >> 3);
    b=b-c;  b=b-a;  b=b^(a << 10);
    c=c-a;  c=c-b;  c=c^(b >> 15);
    return c;
}


void print_testcase(const vector<int> & tc){
	cout << tc.size() << endl;
	cout << tc[0];
	for(int i = 1; i < tc.size(); ++i) cout << " " << tc[i];
	cout << endl;
}

void rotate(vector<int> & tc){
	int r = rnd(0, n-1);
	rotate(tc.begin(), tc.begin() + r, tc.end());
}

void generate_sample(vector<int> & tc){
	for(int i = 0; i < n; ++i) tc[i] = i&1;
}

void generate_random_symmetric(vector<int> & tc){
	vector<int> d;
	for(int i = 0; i < n/2; ++i){
		d.push_back(rnd(0,1));
	}
	tc[0] = 1000000;
	for(int i = 0; i < n/2; ++i){
		tc[i+1] = tc[i] + ((d[i] == 1) ? 1 : -1);
	}
	for(int i = n/2+1; i < n; ++i){
		tc[i] = tc[i-1] + ((d[n-i] == 1) ? -1 : 1);
	}
	rotate(tc);
}

void generate_bimonotone(vector<int> & tc){
	tc[0] = 1000000;
	for(int i = 0; i < n/2; ++i){
		tc[i+1] = tc[i]+1;
	}
	for(int i = n/2; i < n-1; ++i){
		tc[i+1] = tc[i] - 1;
	}
	rotate(tc);
}


vector<int> rnd_dyck_word(int m){ //of size 2m
	set<int> ones;
	while(ones.size() < m){
		ones.insert(rnd(0, 2*m-1));
	}
	vector<int> w(2*m, -1);
	for(auto x : ones) w[x] = 1;
	int mini = 0, mn = 0, sm = 0, cnt = 1;
	for(int i = 0; i < 2*m; ++i){
		sm += w[i];
		if(sm < mn){
			mn = sm;
			mini = i+1;
			cnt = 0;
		}
		if(sm == mn) ++cnt;
	}
	assert(mini != 2*m);
	rotate(w.begin(), w.begin() + mini, w.end());
	//cerr << "Dyck word had " << cnt << " minima." << endl;
	return w;
}

void generate_random_with_one_extreme(vector<int> & tc){
	vector<int> dw = rnd_dyck_word(n/4 - 1);
	/*vector<int> b(n/2);
	b[0] = 0;
	b[1] = 2;
	for(int i = 2; i < n/2;++i) b[i] = b[i-1] + 2*dw[i-2];*/

	tc[0] = tc[n/2] = 1000000;
	tc[1] = 1000001;
	tc[1+n/2] = 1000000-1;
	for(int i = 2; i < n/2; ++i){
		tc[i] = tc[i-1] + dw[i-2];
		tc[i + n/2] = tc[i + n/2 - 1] - dw[i-2];
	}
	rotate(tc);
}


int main(int argc, char ** argv){
	

	vector<string> args(argv+1, argv+argc);

	unsigned long seed1 = stoi(args[0]);
	unsigned long seed2 = stoi(args[1]);


	unsigned long seed = mix(seed1, 4742, seed2*n);
	//cerr << seed << endl;
	srand(seed);

	set<char> types = {
		's', //sample
		'r', //random symmetric
		'b', //bimonotone
		'd', //dyck
	};

	char type = args[2][0];
	assert(types.find(type) != types.end());

	vector<int> tc(n);

	if(type == 's'){
		generate_sample(tc);
	}
	if(type == 'r'){
		generate_random_symmetric(tc);
	}
	if(type == 'b'){
		generate_bimonotone(tc);
	}

	if(type == 'd')
		generate_random_with_one_extreme(tc);

	cout << n << endl;
	for(auto x : tc){
		cout << x << " ";
	}
	cout << endl;


} 