#include <bits/stdc++.h>

using namespace std;

int n;
vector<int> t;
int L = 100000;

void error(const string &message) { cerr << message << endl; exit(1); }

vector<int> thresholds = { 1000000, 100000, 50000, 26000, 5000, 2000, 1000, 350, 100, 34, 32, -1 };

int points(int q) {
    int i = 0;
    while (thresholds[i + 1] >= q) ++i;
    return i;
}

int main(int argc, char ** argv) {
    const char *infile;
    if (argc == 1)
        infile = "planeta.in";
    else if (argc == 2)
        infile = argv[1];
    else
        error("Jako argument zadej jméno vstupního souboru.");

    ifstream planeta;
    planeta.open(infile);

    if (planeta.is_open()) {
        if (!(planeta >> n)) error("První řádek souboru musí obsahovat číslo n.");
        if (n&1) error("Planeta musí mít sudý počet vrcholů.");
        if (n < 2 || n > 100000) error("Číslo n musí ležet v intervalu [2, 10^5].");

        t.resize(n);
        for (int i = 0; i < n; ++i){
            if (!(planeta >> t[i])) error("Soubor neobsahuje správné množství teplot.");
            if (t[i] < -273 || t[i] > 1000000000) error("Teplota musí být celé číslo mezi -273 a 10^9.");
        }
        planeta.close();
    } else {
        cerr << "Soubor s názvem " << infile << " neexistuje." << endl;
        return 1;
    }

    int x, y;
    int q = 0;

    while (true) {
        if (!(cin >> x)) error("Výstup skončil bez výpisu odpovědi.");
        if (x != 0 && x != 1) error("Očekáváno číslo 0 nebo 1.");
        if (x == 1) break;
        if (++q > L) error("Příliš mnoho otázek.");
        int y;
        if (!(cin >> y)) error("V otázce chybí číslo vrcholu.");
        if (y < 0 || y >= n) error("Chybné číslo vrcholu v otázce.");
        cout << t[y] << endl << flush;
    }

    if (!(cin >> y)) error("V odpovědi chybí číslo vrcholu.");
    if (y < -1 || y >= n/2) error("Druhé číslo v odpovědi musí být alespoň -1 a menší než n/2.");

    bool ok;
    if (y == -1) {
        ok = true;
        for (int i = 0; i < n/2; ++i) if (t[i] == t[i+n/2]) ok = false;
    } else {
        ok = t[y] == t[y + n/2];
    }

    if (ok) {
        cerr << "Správná odpověď s pomocí " << q << " otázek. Počet bodů: " << points(q) << "." << endl;
    } else {
        cerr << "Nesprávná odpověď." << endl;
    }

    return 0;
}
